=== specification/requirements.txt ===
# Copyright 2017-2025 The Khronos Group Inc.
# SPDX-License-Identifier: Apache-2.0

# Optional but recommended for check spec links
termcolor

# Optional but recommended for check spec links on Windows
colorama

# Optional but recommended for check spec links
tabulate

# Optional but recommended: needed for scripts/xml_consistency.py
networkx

# Optional: bundled copy may be in ../external/python
jinja2

# for spec diffs
pypdf2
pdf_diff

# For testing
pytest

# for python doc builds
pdoc3
