=== debian/changelog ===
openxr-sdk-source (1.1.47~ds-2) unstable; urgency=medium

  * d/control: Build-Depends on pyparsing.

 -- Rylie Pavlik <rylie@ryliepavlik.com>  Thu, 24 Apr 2025 17:56:03 -0500

openxr-sdk-source (1.1.47~ds-1) unstable; urgency=medium

  * New upstream version 1.1.47~ds. Highlights include:
    - OpenXR 1.1 core spec revision. (Header/loader usable for 1.0 and 1.1.)
    - Many new extensions in the headers.
    - loongarch64 architecture support added, ARMv6 support fixed.
    - New `XR_API_VERSION_1_0` and `XR_API_VERSION_1_1` defines to allow
      applications to easily specify OpenXR "major" and "minor" version while
      passing through the "patch" version.
    - Substantial fixes to API layers, especially validation layer.
  * Rediff patches
  * d/libopenxr-loader1.symbols: Update for new 1.1 core symbol
  * d/copyright: update

 -- Rylie Pavlik <rylie@ryliepavlik.com>  Wed, 23 Apr 2025 17:44:50 -0500
